//+------------------------------------------------------------------+
//|                                        Custom Moving Average.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- indicator parameters
extern int ExtDepth=10;
extern int ExtDeviation=0;
extern int ExtBackstep=0;
extern int from=0;
//---- indicator buffers
double ExtMapBuffer[];
double ExtMapBuffer2[];

#define sZZname "zzLine"

double Range = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_SECTION);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(0,0.0);
   ArraySetAsSeries(ExtMapBuffer,true);
   ArraySetAsSeries(ExtMapBuffer2,true);
//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done

   DeleteObjects();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;


      Range=0;
      double AvgRange=0;

   for(shift=Bars-ExtDepth; shift>=from; shift--)
     {
      for (int counter=shift ;counter<=shift+9;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10; Range = 1;

      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer[shift+back];
               if((res!=0)&&(res>val)) ExtMapBuffer[shift+back]=0.0; 
              }
           }
        } 
      ExtMapBuffer[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBuffer2[shift+back];
               if((res!=0)&&(res<val)) ExtMapBuffer2[shift+back]=0.0; 
              } 
           }
        }
      ExtMapBuffer2[shift]=val;
     }

   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=from; shift--)
     {
      curlow=ExtMapBuffer[shift];
      curhigh=ExtMapBuffer2[shift];
//      if((curlow==0.0)||(curhigh==0.0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh) ExtMapBuffer2[lasthighpos]=0;
            else ExtMapBuffer2[shift]=0;
           }//
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }// 
         lastlow=-1;
        }//
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow) ExtMapBuffer[lastlowpos]=0;
            else ExtMapBuffer[shift]=0;
           }//z
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           }//z 
         lasthigh=-1;
        }//
     }
  
   for(shift=Bars-1; shift>=from; shift--)
     {
      if(shift>=Bars-ExtDepth) ExtMapBuffer[shift]=0.0;
      else
        {
         res=ExtMapBuffer2[shift];
         if(res!=0.0) ExtMapBuffer[shift]=res;         
        }
     }

   DeleteObjects();
   
   int pShift = 0;
   for(shift=Bars-1; shift>=from; shift--)
     {
      if(ExtMapBuffer2[shift]!=0.0) 
      {
         CreateObject(shift, pShift, true); 
         pShift = shift; 
      }
      else 
         if(ExtMapBuffer[shift] > 0.0)
         {
            CreateObject(shift, pShift, false);
            pShift = shift;
         }

     }


   double aZZ[10]; int aBars[10];
   for(int ix=0; ix<10; ix++) aZZ[ix] = 0.0;
   ix = 0;
   for(shift=Bars-1; shift>=0; shift--)
     {
     if (shift < 120)
      if (ExtMapBuffer[shift]>0 || ExtMapBuffer2[shift] > 0)
      {
            if (ix > 4)
            {
               for(int ii=0; ii<5; ii++)
               {
                  aZZ[ii] = aZZ[ii+1];
                  aBars[ii] = aBars[ii+1];
               }
               ix = 4;
            }
            aZZ[ix] = ExtMapBuffer[shift];
            aBars[ix] = shift;
            if (ExtMapBuffer2[shift]>0)
               aZZ[ix] = ExtMapBuffer2[shift];
            ix++;
      }
   }

   static int iShift = -5;
   
   //if (iShift != aBars[0])
   {
      CreateTxt("X", aBars[0]);
      CreateTxt("A", aBars[1]);
      CreateTxt("B", aBars[2]);
      CreateTxt("C", aBars[3]);
      CreateTxt("D", aBars[4]);
      CreateLine(aBars[4], aBars[3], aBars[2]);
      CreateLine(aBars[2], aBars[1], aBars[0]);
      CreateLine(aBars[3], aBars[2], aBars[1]);
      CreateLine(aBars[4], aBars[1], aBars[0]);
      iShift = aBars[0];
   }
}
  

void CreateObject(int shift, int pShift, bool bHigh)
{
   static int ndx = 0;
   
   ndx++;
   datetime dt = Time[shift];
   double prc, siz;
   
   string sTxt = "";
   
   if (bHigh)
   {
      prc = High[shift] + (10 * Range) * Point;
      siz = (High[shift] - Low[pShift]) / Point;
      sTxt = "h " + High[shift] + "  " + Low[pShift];
   }
   else
   {
      prc = Low[shift] - (3 * Range)*Point;
      siz = (High[pShift] - Low[shift]) / Point;
      sTxt = "l " + High[pShift] + "  " + Low[shift];
   }
   ObjectCreate(sZZname+ndx, OBJ_TEXT, 0, dt, prc);
   ObjectSetText(sZZname+ndx, "["+DoubleToStr(pShift - shift,0)+ "] " + DoubleToStr(siz,0), 10);
}
  
void DeleteObjects()
{
  int    obj_total=ObjectsTotal();
  string names[500];
  for(int i=0;i<obj_total;i++)
    {
     names[i]=ObjectName(i);
    }
  for(i=0;i<obj_total;i++)
    {
      if (StringSubstr(names[i],0,StringLen(sZZname)) == sZZname)
         ObjectDelete(names[i]);
    }
}

void CreateLine(int b0, int b1, int b2)
{
   double p0, p1, p2;
   static int ndx = 1;
   string lineName = sZZname+"Line"+ndx;
   if (ExtMapBuffer2[b0] > 0) p0 = High[b0]; else p0 = Low[b0];
   if (ExtMapBuffer2[b1] > 0) p1 = High[b1]; else p1 = Low[b1];
   if (ExtMapBuffer2[b2] > 0) p2 = High[b2]; else p2 = Low[b2];
   
   
   ObjectCreate(lineName, OBJ_TREND, 0, 
      iTime(NULL,0,b0), p0,iTime(NULL,0,b2), p2);
   ObjectSet(lineName, OBJPROP_RAY, 0);
   ObjectSet(lineName, OBJPROP_COLOR, Blue);
   ObjectSet(lineName, OBJPROP_STYLE, STYLE_DOT);
   
   
   int ib = ((b2 - b0)/ 2) + b0;
   ObjectCreate(lineName + ndx, OBJ_TEXT, 0, iTime(NULL,0, ib), (p0+p2)/2);
   //-----
   //p0 = 95.28; p1 = 120; p2 = 100;
   double BC = MathAbs(p2-p1);
   double CD = MathAbs(p0-p1);
   double r0 = 0.0, r1;
   
   //if (p0 > p1)
      r0 = BC / CD;
   //else
      r1 = CD / BC;
 
   ObjectSetText(lineName + ndx, DoubleToStr(r0,4)+" "+DoubleToStr(r1,4), 10);
     
   ndx++;
}

void CreateTxt(string txt, int shift)
{
   static int ndx = 1;
   double p0;
   return;
   
   if (ExtMapBuffer2[shift] > 0) p0 = High[shift] + (5 * Range)*Point; else p0 = Low[shift] - (5 * Range)*Point;
   ObjectCreate(sZZname + "txt"+ndx, OBJ_TEXT, 0, iTime(NULL,0, shift+2), p0);
   ObjectSetText(sZZname + "txt"+ndx, txt, 12);
   ndx++;
}